/**

*/
import java.util.Random;

public class BagTest
{
   private static final int ITERATIONS = 1_000_000;
   private static final int RANDOM_RANGE = 1_000;

   public static void main(String[] args)
   {
      Random rand = new Random();

      IntBag bag1 = new IntArrayBag();
      IntBag bag2 = new IntArraysBag();

      // fill the bags
      for (int i = 0; i < ITERATIONS; i++)
      {
         int element = rand.nextInt(RANDOM_RANGE);
         bag1.add( element );
         bag2.add( element );
      }

      System.out.println("The bags have been filled.");

      // check that the two bags contain the same thing
      boolean fail = false;
      for (int i = 0; i < RANDOM_RANGE; i++)
      {
         int count1 = bag1.countOccurrences( i );
         int count2 = bag2.countOccurrences( i );
         if ( count1 != count2 )
         {
            fail = true;
            System.out.println("There is a problem with the Bag implementations.");
         }
      }

      if (! fail)
      {
         System.out.println("The Bag implementations passed the first test.");
      }

      // empty the bags
      for (int i = 0; i < RANDOM_RANGE; i++)
      {
         int count = bag2.countOccurrences( i );
         for (int j = 0; j < count; j++)
         {
            bag1.remove(i);
            bag2.remove(i);
         }
      }

      // check that the bags are empty
      if ( (0 == bag1.size()) && (0 == bag2.size()) )
      {
         System.out.println("The Bag implementations passed the second test.");
      }
      else
      {
         System.out.println("There is a problem with the Bag implementations.");
      }
   }
}